VERSION 5.00
Begin VB.UserControl Analog 
   ClientHeight    =   3900
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3900
   ScaleWidth      =   4800
   Begin VB.PictureBox picAnalog 
      Appearance      =   0  '2D
      BackColor       =   &H80000005&
      BorderStyle     =   0  'Kein
      ForeColor       =   &H80000008&
      Height          =   2895
      Left            =   0
      ScaleHeight     =   2895
      ScaleWidth      =   4005
      TabIndex        =   0
      Top             =   0
      Width           =   4000
   End
   Begin VB.Label lblWert 
      Alignment       =   2  'Zentriert
      BackColor       =   &H80000005&
      Caption         =   "0"
      Height          =   255
      Left            =   1200
      TabIndex        =   2
      Top             =   3480
      Width           =   2415
   End
   Begin VB.Label lblText 
      Alignment       =   2  'Zentriert
      BackColor       =   &H80000005&
      Caption         =   "0"
      Height          =   255
      Left            =   1200
      TabIndex        =   1
      Top             =   3120
      Width           =   2415
   End
End
Attribute VB_Name = "Analog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' ------------------------------------------------------------------------------
'
' Analog(Analog.ctl)                                      Ulrich Mller 20.10.01
'                                                         Procida 400NT    VB6.0
' Analoge Anzeige von der EX/EY-Eingnge der fischertechnik Interfaces
'
' ------------------------------------------------------------------------------

Option Explicit

Public Enum DTypes
  ftiSegment = 1
  ftiVertikal = 2
  ftiHorizontal = 3
End Enum

Event GotLow(ByVal actValue!)    ' --- Eintritt in den Low-Bereich
Attribute GotLow.VB_Description = "akt. Mewert in die LowArea eingetreten"
Event GotNormal(ByVal actValue!) '     Eintritt in den Normal-Bereich
Attribute GotNormal.VB_Description = "akt. Mewert in die NormalArea eingetreten"
Event GotHigh(ByVal actValue!)   '     Eintritt in den High-Bereich
Attribute GotHigh.VB_Description = "akt. Mewert in die HighArea eingetreten"
Event IsLow(ByVal actValue!)     ' --- Mewert im Low-Bereich
Attribute IsLow.VB_Description = "akt. Mewert liegt in der LowArea"
Event IsNormal(ByVal actValue!)  '     Mewert im Normal-Bereich
Attribute IsNormal.VB_Description = "akt. Mewert liegt in der NormalArea"
Event IsHigh(ByVal actValue!)    '     Mewert im High-Bereich
Attribute IsHigh.VB_Description = "akt. Mewert liegt in der HighArea"

Private minAWert!                ' --- min. anzuzeigender Wert(MinUnit)
Private maxAWert!                '     max. anzuzeigender Wert(MaxUnit)
Private minMWert&                ' --- min. zu messender Wert(MinValue)
Private maxMWert&                '     max. zu messender Wert(MaxValue)
Private mExchanged As Boolean    ' --- vertauschen der Anzeigerichtung
Private mDisplayName$            ' --- anzuzeigender MewertName(Description)
Private mDisplayUnit$            '     anzuzeigende Maeinheit(Units)
Private mLowArea!                ' --- Ende Low-Area (in Units)
Private mHighArea!               '     Beginn High-Area (in Units)
Private mDType As DTypes         ' --- Aktueller Displaytyp
Private mEventsActivated As Boolean '  Zulassen der Events

Private LastValue!               ' --- Letzter angezeigter Wert



Public Property Let Description(ByVal wert$)
Attribute Description.VB_Description = "anzuzeigender MewertName"
  mDisplayName = wert
  ShowValue minMWert
  PropertyChanged "Description"
End Property

Public Property Get Description() As String
  Description = mDisplayName
End Property


Public Property Let DisplayType(ByVal wert As DTypes)
Attribute DisplayType.VB_Description = "Typ des anzuzeigenden Meinstruments"
  mDType = wert
  ShowValue minMWert
  PropertyChanged "DisplayType"
End Property

Public Property Get DisplayType() As DTypes
  DisplayType = mDType
End Property

Public Property Get EventsActivated() As Boolean
Attribute EventsActivated.VB_Description = "Aktivieren der Ereignisroutinen"
  EventsActivated = mEventsActivated
End Property

Public Property Let EventsActivated(ByVal boolValue As Boolean)
  mEventsActivated = boolValue
End Property

Public Property Let HighArea(ByVal uValue!)
Attribute HighArea.VB_Description = "Beginn des Bereichs der hohen Mewerte"
  If uValue > maxAWert Or uValue < minAWert Then mHighArea = maxAWert Else mHighArea = uValue
  PropertyChanged "HighArea"
End Property

Public Property Get HighArea() As Single
  HighArea = mHighArea
End Property

Public Property Let LowArea(ByVal uValue!)
Attribute LowArea.VB_Description = "Ende des Bereichs der niedrigen Mewerte"
  If uValue < minAWert Or uValue > maxAWert Then mLowArea = minAWert Else mLowArea = uValue
  PropertyChanged "LowArea"
End Property

Public Property Get LowArea() As Single
  LowArea = mLowArea
End Property


Private Sub ResizeSegment()
  
  If Width < 2175 Then Width = 2175
  If Height < 1215 Then Height = 1215
  lblText.Left = 0
  lblText.Top = UserControl.Height - lblText.Height
  lblText.Width = UserControl.Width
  picAnalog.Left = 0
  picAnalog.Top = 0
  picAnalog.Width = UserControl.Width
  picAnalog.Height = UserControl.Height - lblText.Height - 50
  If mExchanged Then ShowValue maxMWert Else ShowValue minMWert

End Sub

Private Sub ResizeVertical()
  
  If Width < 1000 Then Width = 1000
  If Height < 2000 Then Height = 2000
  
  lblText.Left = 0
  lblText.Top = UserControl.Height - lblText.Height - lblWert.Height
  lblText.Width = UserControl.Width
  lblWert.Left = 0
  lblWert.Top = UserControl.Height - lblWert.Height
  lblWert.Width = UserControl.Width
  
  picAnalog.Left = 0
  picAnalog.Top = 0
  picAnalog.Width = UserControl.Width
  picAnalog.Height = UserControl.Height - lblText.Height - lblWert.Height - 40
  If mExchanged Then ShowValue maxMWert Else ShowValue minMWert

End Sub

Private Function ShowSegment(ByVal rawValue&) As Single

' --- Zeichnen des AnalogInstruments vom Typ ftiSegment --------------
'     Eintrag des aktuellen Mewertes

Const kStrich = 5!, lStrich = 8!, anzStriche = 21, sWinkel = 1.05!, iRadius = 75!
Const zRadius = 40!, zStrich = 48!
Dim dWinkel!, aWinkel!, sWert!
Dim zTeilung!
Dim X!, Y!, x1!, y1!, x2!, y2!, w!
Dim i&

On Error GoTo SFehler

  picAnalog.DrawStyle = vbSolid
  picAnalog.DrawWidth = 1
  Select Case picAnalog.Width
  Case Is < 3000
    picAnalog.FontSize = 8
  Case Is < 5000
    picAnalog.FontSize = 10
  Case Else
    picAnalog.FontSize = 12
  End Select
  zTeilung = (maxAWert - minAWert) / 4
  picAnalog.Cls
  picAnalog.Scale (-50, 100)-(50, 20)
  
' ---------- Minor Ticks ---------------------------

  aWinkel = sWinkel
  dWinkel = sWinkel / (anzStriche - 1)
  For i = 1 To anzStriche
    x1 = Cos(aWinkel) * iRadius
    y1 = Sin(aWinkel) * iRadius
    x2 = x1 + Cos(aWinkel) * kStrich
    y2 = y1 + Sin(aWinkel) * kStrich
    picAnalog.Line (x1, y1)-(x2, y2)
    aWinkel = aWinkel + dWinkel
  Next i
  
' ------------ Major Ticks -----------------
  aWinkel = sWinkel
  sWert = maxAWert
  dWinkel = sWinkel / ((anzStriche - 1) / 5)
  For i = 1 To (anzStriche - 1) / 5 + 1
    x1 = Cos(aWinkel) * iRadius
    y1 = Sin(aWinkel) * iRadius
    x2 = x1 + Cos(aWinkel) * lStrich
    y2 = y1 + Sin(aWinkel) * lStrich
    picAnalog.Line (x1, y1)-(x2, y2)
    picAnalog.CurrentX = x2 - 5!
    picAnalog.CurrentY = y2 + 10!
    picAnalog.Print sWert
    aWinkel = aWinkel + dWinkel
    sWert = sWert - zTeilung
  Next i

' -------- Low/High-Marken --------------------------------------
  
  picAnalog.DrawWidth = 2
  If mLowArea > minAWert Then
    aWinkel = sWinkel + ((maxAWert - mLowArea) / (maxAWert - minAWert)) * sWinkel
    x1 = Cos(aWinkel) * (iRadius + kStrich)
    y1 = Sin(aWinkel) * (iRadius + kStrich)
    x2 = x1 + Cos(aWinkel) * kStrich
    y2 = y1 + Sin(aWinkel) * kStrich
    picAnalog.Line (x1, y1)-(x2, y2), QBColor(9)
  End If
  If mHighArea < maxAWert Then
    aWinkel = sWinkel + ((maxAWert - mHighArea) / (maxAWert - minAWert)) * sWinkel
    x1 = Cos(aWinkel) * (iRadius + kStrich)
    y1 = Sin(aWinkel) * (iRadius + kStrich)
    x2 = x1 + Cos(aWinkel) * kStrich
    y2 = y1 + Sin(aWinkel) * kStrich
    picAnalog.Line (x1, y1)-(x2, y2), QBColor(12)
  End If
  picAnalog.DrawWidth = 1
  
' -------------- Analog Wert ------------------------------------

  w = ValueToUnit(rawValue)
  aWinkel = sWinkel + ((maxAWert - w) / (maxAWert - minAWert)) * sWinkel
  
  x1 = Cos(aWinkel) * zRadius
  y1 = Sin(aWinkel) * zRadius
  x2 = x1 + Cos(aWinkel) * zStrich
  y2 = y1 + Sin(aWinkel) * zStrich
  If w <= minAWert Or w >= maxAWert Then picAnalog.DrawStyle = vbDashDot
  picAnalog.Line (x1, y1)-(x2, y2), QBColor(12)
  picAnalog.DrawStyle = vbSolid
  
' -------------- Digital Wert ------------------------------

  lblText.Caption = mDisplayName & " : " & Format$(w, "0.00") & " " & mDisplayUnit
  ShowSegment = w
  Exit Function
SFehler:
  ShowSegment = 0
End Function

Private Function ShowVertical(ByVal rawValue&) As Single

' --- Zeichnen des AnalogInstruments vom Typ ftiVertical --------------
'     Eintrag des aktuellen Mewertes

Const kStrich = 5!, lStrich = 8!, anzStriche = 21, dY = 5!, rX = 28!
Dim sWert!, zTeilung!, aY!, Y!, w!, i&, fmt$

On Error GoTo VFehler

  picAnalog.DrawStyle = vbSolid
  picAnalog.DrawWidth = 1
  Select Case picAnalog.Width
  Case Is < 1200
    picAnalog.FontSize = 8
  Case Is < 1600
    picAnalog.FontSize = 10
  Case Else
    picAnalog.FontSize = 12
  End Select
  zTeilung = (maxAWert - minAWert) / 4
  picAnalog.Cls
  picAnalog.Scale (0, 110)-(30, -10)
  
' ---------- Minor Ticks ---------------------------

  aY = 0
  For i = 1 To anzStriche
    picAnalog.Line (rX - kStrich, aY)-(rX, aY)
    aY = aY + dY
  Next i
  
' ------------ Major Ticks -----------------
  
  aY = 0
  sWert = minAWert
  For i = 1 To (anzStriche - 1) / 5 + 1
    picAnalog.Line (rX - lStrich, aY)-(rX, aY)
    picAnalog.CurrentX = 5!
    picAnalog.CurrentY = aY + 5!
    picAnalog.Print sWert
    aY = aY + dY * 5
    sWert = sWert + zTeilung
  Next i

' -------- Low/High-Marken --------------------------------------
  
  picAnalog.DrawWidth = 2
  If mLowArea > minAWert Then
    Y = (mLowArea / (maxAWert - minAWert)) * 100!
    picAnalog.Line (rX - kStrich, Y)-(rX - lStrich - 3, Y), QBColor(9)
  End If
  If mHighArea < maxAWert Then
    Y = (mHighArea / (maxAWert - minAWert)) * 100!
    picAnalog.Line (rX - kStrich, Y)-(rX - lStrich - 3, Y), QBColor(12)
  End If
  
' -------------- Analog Wert ------------------------------------

  w = ValueToUnit(rawValue)
  Y = (w / (maxAWert - minAWert)) * 100!
  If w <= minAWert Or w >= maxAWert Then picAnalog.DrawStyle = vbDashDot
  picAnalog.Line (rX, Y)-(rX - lStrich - 3, Y), QBColor(12)
  picAnalog.Line (rX, Y - 2)-(rX, Y + 2), QBColor(12)
  picAnalog.DrawStyle = vbSolid
  picAnalog.DrawWidth = 1
  
' -------------- Digital Wert ------------------------------

  lblText.Caption = mDisplayName
  Select Case w
  Case Is < 10
    fmt = "0.00"
  Case Is < 100
    fmt = "0.0"
  Case Else
    fmt = "0"
  End Select
  lblWert.Caption = Format$(w, fmt) & " " & mDisplayUnit
  ShowVertical = w
  Exit Function
VFehler:
  ShowVertical = 0

End Function

Public Property Let Units(ByVal wert$)
Attribute Units.VB_Description = "anzuzeigende Mewerteinheit"
  mDisplayUnit = wert
  ShowValue minMWert
  PropertyChanged "Units"
End Property

Public Property Get Units() As String
  Units = mDisplayUnit
End Property

Public Property Let MaxUnit(ByVal uValue!)
Attribute MaxUnit.VB_Description = "max. anzuzeigender Wert"
  maxAWert = uValue
  ShowValue minMWert
  PropertyChanged "MaxUnit"
End Property

Public Property Get MaxUnit() As Single
  MaxUnit = maxAWert
End Property

Public Property Let MinUnit(ByVal uValue!)
Attribute MinUnit.VB_Description = "min. anzuzeigender Wert"
  minAWert = uValue
  ShowValue minMWert
  PropertyChanged "MinUnit"
End Property

Public Property Get MinUnit() As Single
  MinUnit = minAWert
End Property

Public Property Let MaxValue(ByVal rawValue&)
Attribute MaxValue.VB_Description = "max. zu messender Wert"
  maxMWert = rawValue
  ShowValue minMWert
  PropertyChanged "MaxValue"
End Property

Public Property Get MaxValue() As Long
  MaxValue = maxMWert
End Property

Public Property Let MinValue(ByVal rawValue&)
Attribute MinValue.VB_Description = "min. zu messender Wert"
  minMWert = rawValue
  ShowValue minMWert
  PropertyChanged "MinValue"
End Property

Public Property Get MinValue() As Long
  MinValue = minMWert
End Property

Public Property Let Exchanged(ByVal boolValue As Boolean)
Attribute Exchanged.VB_Description = "Vertauschen der Anzeigerichtung (gerer Zeigerausschlag, kleinerer Mewert)"
  mExchanged = boolValue
  ShowValue minMWert
  PropertyChanged "Exchanged"
End Property

Public Property Get Exchanged() As Boolean
  Exchanged = mExchanged
End Property

Public Function ShowValue(ByVal rawValue&) As Single
Attribute ShowValue.VB_Description = "Anzeige Instrument mit aktuellem Mewert"

' --- Zeichnen eines Analoginstrumentes und Eintrag des aktuellen Mewertes

Dim unitValue!

  Select Case mDType
  Case DTypes.ftiSegment
    unitValue = ShowSegment(rawValue)
  Case DTypes.ftiVertikal
    unitValue = ShowVertical(rawValue)
  Case Else
    unitValue = ShowSegment(rawValue)
  End Select
  
  If mEventsActivated Then
    Select Case unitValue
    Case Is <= mLowArea
      If LastValue > mLowArea Then
        RaiseEvent GotLow(unitValue)
      Else
        RaiseEvent IsLow(unitValue)
      End If
    Case Is >= mHighArea
      If LastValue < mHighArea Then
        RaiseEvent GotHigh(unitValue)
      Else
        RaiseEvent IsHigh(unitValue)
      End If
    Case Else
      If (LastValue < mLowArea) Or (LastValue > mHighArea) Then
        RaiseEvent GotNormal(unitValue)
      Else
        RaiseEvent IsNormal(unitValue)
      End If
    End Select
  End If
  LastValue = unitValue
  ShowValue = unitValue
  
End Function

Public Function ValueToUnit(ByVal rawValue&) As Single
Attribute ValueToUnit.VB_Description = "Umrechnung eines rawValues (Rohwertes, original Mewertes) in einen unitValue (anzuzeigenden Wert)"

Dim fak!, w!
  
On Error GoTo VFehler

  If mExchanged Then w = minMWert + (maxMWert - rawValue) Else w = rawValue
  If w < minMWert Then w = minMWert
  If w > maxMWert Then w = maxMWert
  
  fak = (maxAWert - minAWert) / (maxMWert - minMWert)
  ValueToUnit = (w - minMWert) * fak + minAWert
  Exit Function
  
VFehler:
  ValueToUnit = 0
End Function


Private Sub UserControl_InitProperties()
  
  minAWert = 0!
  maxAWert = 1000!
  minMWert = 0
  maxMWert = 1000
  mExchanged = False
  mDisplayName = "EX"
  mDisplayUnit = " "
  mDType = ftiSegment
  mLowArea = minAWert
  mHighArea = maxAWert
  mEventsActivated = False
  LastValue = mLowArea + (mHighArea - mLowArea) / 2
  
End Sub

Private Sub UserControl_Paint()
  If mExchanged Then ShowValue maxMWert Else ShowValue minMWert
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

  minAWert = PropBag.ReadProperty("MinUnit", 0!)
  maxAWert = PropBag.ReadProperty("MaxUnit", 1000!)
  minMWert = PropBag.ReadProperty("MinValue", 0)
  maxMWert = PropBag.ReadProperty("MaxValue", 1000)
  mExchanged = PropBag.ReadProperty("Exchanged", False)
  mDisplayName = PropBag.ReadProperty("Description", "EX")
  mDisplayUnit = PropBag.ReadProperty("Units", " ")
  mDType = PropBag.ReadProperty("DisplayTypes", DTypes.ftiSegment)
  mLowArea = PropBag.ReadProperty("LowArea", minAWert)
  mHighArea = PropBag.ReadProperty("HighArea", maxAWert)
  mEventsActivated = PropBag.ReadProperty("EventsActivated", False)
  LastValue = mLowArea + (mHighArea - mLowArea) / 2
  
End Sub


Private Sub UserControl_Resize()

  Select Case mDType
  Case DTypes.ftiSegment
    ResizeSegment
  Case DTypes.ftiVertikal
    ResizeVertical
  Case Else
    ResizeSegment
  End Select
  
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

  PropBag.WriteProperty "MinUnit", minAWert, 0!
  PropBag.WriteProperty "MaxUnit", maxAWert, 1000!
  PropBag.WriteProperty "MinValue", minMWert, 0
  PropBag.WriteProperty "MaxValue", maxMWert, 1000
  PropBag.WriteProperty "Exchanged", mExchanged, False
  PropBag.WriteProperty "Description", mDisplayName, "EX"
  PropBag.WriteProperty "Units", mDisplayUnit, " "
  PropBag.WriteProperty "DisplayTypes", mDType, DTypes.ftiSegment
  PropBag.WriteProperty "LowArea", mLowArea, minAWert
  PropBag.WriteProperty "HighArea", mHighArea, maxAWert
  PropBag.WriteProperty "EventsActivated", mEventsActivated, False
  
End Sub


